import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { DayInfo } from "./DayInfo";
import { XButton } from "./XButton";
import { XIcon } from "./XIcon";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { FirstWeek } from "./FirstWeek";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
/**
 * @hidden
 */
export declare class CalendarView extends Base {
    static $t: Type;
    private n;
    private o;
    private s;
    private q;
    private t;
    private r;
    private g;
    private f;
    private h;
    private j;
    private i;
    private e;
    private p;
    private v;
    constructor();
    c: Calendar;
    k(): List$1<DomWrapper>;
    l(): List$1<DomWrapper>;
    an(): void;
    m: DomRenderer;
    am(a: DomRenderer): void;
    w(): string;
    private z;
    private ac;
    private a3;
    a7(): void;
    private aa;
    private ab;
    private ad;
    a6(): void;
    private a1;
    private av;
    a2(): void;
    private az;
    private a0;
    private ae;
    as(a: any, b: XButton): void;
    ar(a: any, b: string): void;
    aw(a: any, b: XIcon): void;
    ay(): void;
    at(a?: boolean, b?: boolean): void;
    ax(): void;
    a5(): void;
    a4(a: number, b?: boolean): void;
    aq(a?: boolean): void;
    au(a?: boolean): void;
    d(a: DomWrapper): boolean;
    ag(): void;
    private ap;
    private ak;
    private a8;
    private a9;
    private x;
    private y;
    private u;
    private ao;
    private aj;
    private ai;
    private bc;
    private af;
    private ah;
    private ba;
    private bb;
    a(): number[];
    b(a: DomWrapper): number[];
    al(): void;
}
/**
 * @hidden
 */
export declare class Calendar extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private l;
    private static readonly bk;
    private static readonly bl;
    aq: Date;
    private am;
    private ai;
    private aj;
    private ah;
    private ak;
    private al;
    private k;
    private ap;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    close: (sender: any) => void;
    cs(): void;
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    cu(a: Date): void;
    co(a: string, b: string, c: string): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private w;
    private get x();
    private as;
    get aw(): Date;
    set aw(a: Date);
    private ar;
    get av(): Date;
    set av(a: Date);
    private ao;
    get au(): Date;
    set au(a: Date);
    private an;
    get at(): Date;
    set at(a: Date);
    private h;
    get i(): ControlDisplayDensity;
    set i(a: ControlDisplayDensity);
    private f;
    get g(): BaseControlTheme;
    set g(a: BaseControlTheme);
    private c5;
    get df(): Brush;
    set df(a: Brush);
    private db;
    get dl(): Brush;
    set dl(a: Brush);
    private dd;
    get dn(): Brush;
    set dn(a: Brush);
    private c8;
    get di(): Brush;
    set di(a: Brush);
    private da;
    get dk(): Brush;
    set dk(a: Brush);
    private de;
    get dp(): Brush;
    set dp(a: Brush);
    private dc;
    get dm(): Brush;
    set dm(a: Brush);
    private c9;
    get dj(): Brush;
    set dj(a: Brush);
    private c7;
    get dh(): Brush;
    set dh(a: Brush);
    private c6;
    get dg(): Brush;
    set dg(a: Brush);
    private y;
    get ae(): boolean;
    set ae(a: boolean);
    private u;
    get v(): FontInfo;
    set v(a: FontInfo);
    private o;
    get p(): DayOfWeek;
    set p(a: DayOfWeek);
    private r;
    get s(): FirstWeek;
    set s(a: FirstWeek);
    private z;
    get af(): boolean;
    set af(a: boolean);
    protected ct(a: string, b: any, c: any): void;
    protected cv(a: string, b: any, c: any): void;
    private c3;
    private c4;
    cq(): void;
    private c1;
    private c0;
    ch(): void;
    private cx;
    cf(): void;
    ci(a: any, b: any, c: number): void;
    cm(a: any, b: any): void;
    private c2;
    cl(a: any, b: any): void;
    e(a: number, b: number): string[];
    cn(a: any, b: any, c: number): void;
    private cg;
    ag(): List$1<number>;
    private a9;
    private static readonly b;
    private static readonly c;
    private ba;
    private a8;
    private bb;
    private bc;
    private a7;
    private q;
    private a6;
    private bd;
    private static ac;
    ck(a: any, b: any, c: any, d: string): void;
    cj(a: any, b: any, c: string): void;
    a(): boolean[];
    bx(): string;
    by(): string;
    d(a: DayOfWeek): string[];
    n(a: number): DayInfo;
    ad(a: number): boolean;
    aa(a: number, b: number): boolean;
    ab(a: number, b: number): boolean;
    cc(a: number): void;
    cd(a: number): void;
    ce(a: number): void;
    cz(a: number, b: number): void;
    cy(): void;
    bj(): any;
    bs(): string;
    j(): CalendarVisualModelExport;
}
